

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Firmware compiling &mdash; Light Plate Apparatus 0.9 documentation</title>
  

  
  
  
  

  

  
  
    

  

  <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="LED calibration" href="../calibration_led.html" />
    <link rel="prev" title="Firmware programming" href="firmware_programming.html" /> 

  
  <script src="../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../index.html" class="icon icon-home"> Light Plate Apparatus
          

          
          </a>

          
            
            
              <div class="version">
                0.9
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../FAQ/faq.html">FAQ</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../specifications/index.html">Specifications</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../fab/index.html">Fabrication and assembly</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../index.html">Initializing a new device</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="index.html">Firmware</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="firmware_programming.html">Firmware programming</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Firmware compiling</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#installing-the-arduino-libraries">1.      Installing the Arduino Libraries</a></li>
<li class="toctree-l4"><a class="reference internal" href="#downloading-and-building-the-firmware">2.      Downloading and Building the Firmware</a></li>
<li class="toctree-l4"><a class="reference internal" href="#troubleshooting-compilation">3.      Troubleshooting Compilation</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../calibration_led.html">LED calibration</a></li>
<li class="toctree-l2"><a class="reference internal" href="../calibration_time.html">LPA time step calibration</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../using/index.html">Using the LPA</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../contribute/index.html">Contribute</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../links/videos.html">Video tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../links/papers.html">Papers which use LPAs</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Light Plate Apparatus</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../index.html">Initializing a new device</a> &raquo;</li>
        
          <li><a href="index.html">Firmware</a> &raquo;</li>
        
      <li>Firmware compiling</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/initializing/firmware/firmware_compiling.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="firmware-compiling">
<h1>Firmware compiling<a class="headerlink" href="#firmware-compiling" title="Permalink to this headline">¶</a></h1>
<div class="admonition warning">
<p class="first admonition-title">Warning</p>
<p class="last">This procedure lists the steps required to properly compile the firmware’s source code. <strong>It is only recommended if the user intends to modify the firmware for a very particular application</strong>. For regular use, the user is advised to use the precompiled version included with the Supplementary Files (See Supplementary Method on firmware programming).
This section assumes that the user has installed AtmelStudio and the version control software git.</p>
</div>
<div class="section" id="installing-the-arduino-libraries">
<h2>1.      Installing the Arduino Libraries<a class="headerlink" href="#installing-the-arduino-libraries" title="Permalink to this headline">¶</a></h2>
<p>The firmware uses the Arduino libraries to read from the SD card. In order to have access to those libraries, the user must obtain a compiled copy of the Arduino libraries and include them in the firmware project inside Atmel Studio. The following procedure must be followed:</p>
<blockquote>
<div><ol class="loweralpha simple">
<li>Go to <a class="reference external" href="https://www.arduino.cc/en/Main/Software">https://www.arduino.cc/en/Main/Software</a> and download the Arduino Integrated Development Environment (IDE) Windows installer.</li>
<li>Run the installer. Accept the License Agreement, and the defaults in the following windows. The installer will install the Arduino IDE. Click on “Close” when installation is finished.</li>
<li>Open the Arduino IDE. We need to enable verbose mode to locate the compiled libraries. Go to File -&gt; Preferences, and check “Show verbose output during compilation”. Click on the “OK” button.</li>
<li>We must select a board that uses the ATMega328, which is the microcontroller used in the LPA. Go to Tools -&gt; Board, and make sure that “Arduino Uno” is selected.</li>
<li>Compile the default sketch (or any other sketch) by going to Sketch -&gt; Verify/Compile. The black bottom panel in the window will be filled with messages. One of the last messages will start with something similar to “C:Users{Your User Name}AppDataLocalTempbuild3717660540954573100.tmp/”. This is the path of the folder in which the Arduino IDE has placed the compiled Arduino libraries. Open this folder on Windows Explorer.</li>
<li>We need to create a folder to store the compiled libraries. We will do it in the Atmel Studio working directory (by default it is “My DocumentsAtmel Studio”). Open this folder and create a directory called “arduinoCore328”.</li>
<li>Go back to the folder that you opened in step e. The file “core.a” contains the compiled Arduino libraries. Copy this file into the arduinoCore328 folder and rename it to libcore.a. The arduino library is now ready.</li>
</ol>
</div></blockquote>
</div>
<div class="section" id="downloading-and-building-the-firmware">
<h2>2.      Downloading and Building the Firmware<a class="headerlink" href="#downloading-and-building-the-firmware" title="Permalink to this headline">¶</a></h2>
<div class="figure" id="id1" style="width: 100%">
<a class="reference internal image-reference" href="../../_images/firmware_1.png"><img alt="../../_images/firmware_1.png" src="../../_images/firmware_1.png" style="width: 625.95px; height: 422.1px;" /></a>
<p class="caption"><span class="caption-text">On the firmware project properties panel, the “Toolchain” option (left) has been selected, followed by “AVR/GNU Linker -&gt; Libraries” (middle).
The only item in the “Library search path” list, “%HOMEPATH%DocumentsAtmel StudioarduinoCore328”, has been selected.
The “Edit item” button is shown with a red arrow.</span></p>
<div class="legend">
<ol class="loweralpha simple">
<li>The user first needs to obtain the source files. From a command line terminal run the following:</li>
</ol>
<blockquote>
<div><p>git clone –recursive <a class="reference external" href="https://github.com/rice-bioe/LPA-hardware">https://github.com/rice-bioe/LPA-hardware</a>.</p>
<p>This should create a folder called “LPA-hardware”.</p>
</div></blockquote>
<ol class="loweralpha simple" start="2">
<li>Navigate to “LPA-hardwarefirmware”. Open the file “firmware.atsln”. This will open the firmware project in Atmel Studio.</li>
<li>Open the project properties by clicking on Project -&gt; firmware Properties (or pressing Alt + F7). The project properties panel will open. Click on “Toolchain” on the left (Supplementary Fig. S8).</li>
<li>On the list in the middle, navigate to AVR/GNU Linker -&gt; Libraries (Supplementary Fig. S8).</li>
<li>There is one item on the Library search path panel, with the text %HOMEPATH%DocumentsAtmel StudioarduinoCore328 (Supplementary Fig. S8). You need to change this to the folder that you created in steps 1f and 1g. Select this item and click on the “Edit item” button (Supplementary Fig. S8).</li>
<li>A small window should appear. Enter the path of the folder created in steps 1f and 1g, and uncheck the “Relative path” checkbox. Click on “OK”.</li>
<li>Go to Build -&gt; Rebuild Solution (or press Ctrl + Alt + F7) to build the project. No errors (messages with red icons on the “Output” panel at the bottom) should occur. Warning messages (yellow exclamation icons) are acceptable. A file called “firmware.elf” inside the “LPA-hardware/firmware/Debug” folder should have been created. You can program this file into the LPA as in the Supplementary Method on firmware programming.</li>
</ol>
</div>
</div>
</div>
<div class="section" id="troubleshooting-compilation">
<h2>3.      Troubleshooting Compilation<a class="headerlink" href="#troubleshooting-compilation" title="Permalink to this headline">¶</a></h2>
<div class="figure" id="id2" style="width: 100%">
<a class="reference internal image-reference" href="../../_images/firmware_2.png"><img alt="../../_images/firmware_2.png" src="../../_images/firmware_2.png" style="width: 642.4px; height: 515.9px;" /></a>
<p class="caption"><span class="caption-text">On the firmware project properties panel, the “Toolchain” option (left) has been selected, followed by “AVR/GNU C Compiler -&gt; Miscellaneous” (middle).
The figure shows the correct placement of the text “-include ../config.h” inside the “Other flags” text box.</span></p>
</div>
<div class="figure" id="id3" style="width: 100%">
<a class="reference internal image-reference" href="../../_images/firmware_3.png"><img alt="../../_images/firmware_3.png" src="../../_images/firmware_3.png" style="width: 642.4px; height: 515.9px;" /></a>
<p class="caption"><span class="caption-text">On the firmware project properties panel, the “Toolchain” option (left) has been selected, followed by “AVR/GNU C Compiler -&gt; Directories” (middle).
The “Include Paths” list is shown, with the last five entries pointing to Arduino directories. The arrow points to the “Edit item” button.</span></p>
</div>
<p>If step 2g fails, follow the steps below, one at a time, and try step 2g again.</p>
<blockquote>
<div><ol class="loweralpha simple">
<li>Go to Project -&gt; firmware Properties, or press Alt + F7. The project properties panel will open. Click on “Toolchain” on the left. Navigate to “AVR/GNU C Compiler -&gt; Miscellaneous”. Check that “-include ../config.h” (without the quotation marks) is added to the “Other flags” textbox (Supplementary Fig. S9). Repeat the same for “AVR/GNU C++ Compiler -&gt; Miscellaneous”.</li>
<li>Go to Project -&gt; firmware Properties, or press Alt + F7. The project properties panel will open. Click on “Toolchain” on the left. Navigate to “AVR/GNU C Compiler -&gt; Directories”. A list of directories called “Include Paths” will be shown (Supplementary Fig. S10). Check that these entries point to valid locations. As for Arduino 1.6.5, the following directories must be included:</li>
</ol>
<blockquote>
<div><ol class="lowerroman simple">
<li>“{Arduino Installation folder}hardwarearduinoavrcoresarduino”: Contains several header files (<em>.h) and source files (</em>.cpp), including “Arduino.h”.</li>
<li>“{Arduino Installation folder}hardwarearduinoavrvariantsstandard”: Contains “pins_arduino.h”.</li>
<li>“{Arduino Installation folder}librariesSDsrc”: Contains the source files of the SD card reader library, including “File.cpp”, “SD.cpp”, and “SD.h”, among others.</li>
<li>“{Arduino Installation folder}librariesSDsrcutility”: Contains several more source files and headers of the SD card library, such as “Sd2Card.h”, “SdFat.h”, and “SdInfo.h”.</li>
<li>“{Arduino Installation folder}hardwarearduinoavrlibrariesSPI”: Contains source files and headers of the SPI library, a module that is necessary to communicate with the SD card. Files included are “SPI.cpp” and “SPI.h”, among others.</li>
</ol>
</div></blockquote>
</div></blockquote>
<p>The default installation folder is “C:Program Files (x86)Arduino”. If you installed Arduino to a different folder, change the entries in this list to reflect that. It is possible that in a version of Arduino different than 1.6.5 the individual folders have been moved within the Arduino installation folder. If the locations listed above are invalid, you should locate the corresponding folders that match the descriptions above. To modify an entry, select it from the list and click on the “Edit item” button (Supplementary Fig. S10).</p>
<div class="figure" id="id4" style="width: 100%">
<a class="reference internal image-reference" href="../../_images/firmware_4.png"><img alt="../../_images/firmware_4.png" src="../../_images/firmware_4.png" style="width: 642.4px; height: 515.9px;" /></a>
<p class="caption"><span class="caption-text">The Solution Explorer is found in the upper right part of the window. In this example, the file “SPI.cpp” has not been found, which is indicated by the yellow exclamation icon next to the file name.</span></p>
</div>
<p>When you finish, go to “AVR/GNU C++ Compiler -&gt; Directories” on the middle panel and repeat this step.</p>
<blockquote>
<div><ol class="loweralpha simple" start="3">
<li>Check that the necessary source files from the Arduino SD card library are included for compilation. The following files from the Arduino library should be referenced:</li>
</ol>
<blockquote>
<div><ol class="lowerroman simple">
<li>“File.cpp “. Default location: “C:Program Files (x86)ArduinolibrariesSDsrcFile.cpp“</li>
<li>“SD.cpp “. Default location: “C:Program Files (x86)ArduinolibrariesSDsrcSD.cpp”</li>
<li>“Sd2Card.cpp “. Default location: “C:Program Files (x86)ArduinolibrariesSDsrcutilitySd2Card.cpp”</li>
<li>“SdFile.cpp “. Default location: “C:Program Files (x86)ArduinolibrariesSDsrcutilitySdFile.cpp”</li>
<li>“SdVolume.cpp “. Default location: “C:Program Files (x86)ArduinolibrariesSDsrcutilitySdVolume.cpp”</li>
<li>“SPI.cpp “. Default location: “C:Program Files (x86)ArduinohardwarearduinoavrlibrariesSPISPI.cpp”</li>
</ol>
</div></blockquote>
</div></blockquote>
<p>If you installed Arduino to a different folder than “C:Program Files (x86)Arduino”, the references need to be changed to reflect this. It is possible than in a version of Arduino different than 1.6.5, the files are located in different folders within the Arduino installation folder. If a reference is not found, it will have an exclamation icon next to its name in the Solution Explorer panel in Atmel Studio (Supplementary Fig. S11). To correct this, do the following for each missing file:</p>
<ol class="arabic simple">
<li>Obtain the true location of the file in the Arduino installation folder.</li>
<li>On the Solution Explorer in Atmel Studio, right click on the problematic file and select “Remove”.</li>
<li>Go to “Project -&gt; firmware Properties”, and then to “Project -&gt; Add existing item”.</li>
<li>A dialog will open to select a file. Navigate to the true location of the file and select it. Click on the arrow next to the “Add” button (lower right of the dialog) and select “Add as link”.</li>
</ol>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../calibration_led.html" class="btn btn-neutral float-right" title="LED calibration" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="firmware_programming.html" class="btn btn-neutral" title="Firmware programming" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Tabor Lab

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
        <script type="text/javascript" src="../../_static/jquery.js"></script>
        <script type="text/javascript" src="../../_static/underscore.js"></script>
        <script type="text/javascript" src="../../_static/doctools.js"></script>
    

  

  <script type="text/javascript" src="../../_static/js/theme.js"></script>

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>